/**
 * Generated by @openapi-codegen
 *
 * @version 1.0.0
 */
import { UserUserview } from '@aei/types';

/**
 * L'entité représentant une category.
 *
 * @deprecated false
 */
export type Category = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * le nom.
   */
  name: string;
  /**
   * la photo.
   */
  picture: string;
  /**
   * la description.
   */
  description?: string | null;
  position?: number | null;
};

/**
 * @deprecated false
 */
export type CategoryInterventionViewInterventionGet = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * le nom.
   */
  name: string;
  /**
   * la photo.
   */
  picture: string;
  /**
   * la description.
   */
  description?: string | null;
};

/**
 * @deprecated false
 */
export type CategoryInterventionViewInterventionGetCollection = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * le nom.
   */
  name: string;
  /**
   * la photo.
   */
  picture: string;
  /**
   * la description.
   */
  description?: string | null;
};

/**
 * @deprecated false
 */
export type CategoryTypeGet = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * le nom.
   */
  name: string;
  /**
   * la photo.
   */
  picture: string;
  /**
   * la description.
   */
  description?: string | null;
  position?: number | null;
};

/**
 * L'entité représentant un commentaire.
 *
 * @deprecated false
 */
export type Comment = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * le message.
   */
  message: string;
  /**
   * la date de création.
   *
   * @format date-time
   */
  createdAt?: string;
  /**
   * l'auteur.
   *
   * @format iri-reference
   * @example https://example.com/
   */
  author?: string;
  /**
   * l'intervention.
   *
   * @format iri-reference
   * @example https://example.com/
   */
  intervention: string;
};

/**
 * L'entité représentant un commentaire.
 *
 * @deprecated false
 */
export type CommentCommentPost = {
  /**
   * le message.
   */
  message: string;
  /**
   * l'intervention.
   *
   * @format iri-reference
   * @example https://example.com/
   */
  intervention: string;
};

/**
 * @deprecated false
 */
export type CommentInterventionViewInterventionGet = {
  /**
   * le message.
   */
  message: string;
  /**
   * la date de création.
   *
   * @format date-time
   */
  createdAt?: string;
  /**
   * l'auteur.
   */
  author?: UserUserview;
};

/**
 * L'entité représentant un employeur.
 *
 * @deprecated false
 */
export type Employer = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * le numéro SIREN.
   */
  siren: string;
  /**
   * le prénom.
   */
  name: string;
  /**
   * la longitude.
   */
  longitude: string;
  /**
   * la latitude.
   */
  latitude: string;
  /**
   * les utilisateurs.
   */
  users?: string[];
};

/**
 * L'entité représentant un employeur.
 *
 * @deprecated false
 */
export type EmployerEmployerViewEmployerGet = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * le numéro SIREN.
   */
  siren: string;
  /**
   * le prénom.
   */
  name: string;
  /**
   * la longitude.
   */
  longitude: string;
  /**
   * la latitude.
   */
  latitude: string;
};

/**
 * @deprecated false
 */
export type EmployerUserViewUserGetCollection = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * le prénom.
   */
  name: string;
};

/**
 * @deprecated false
 */
export type EmployerUserViewUserGetCollectionUserGet = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * le prénom.
   */
  name: string;
};

/**
 * L'entité représentant une intervention.
 *
 * @deprecated false
 */
export type Intervention = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * identifiant logique avec une numérotation pour chaque employer
   */
  logicId?: number;
  /**
   * la date de création.
   *
   * @format date-time
   */
  createdAt?: string;
  /**
   * la description
   */
  description?: string | null;
  /**
   * le statut.
   */
  status: 'to-validate' | 'blocked' | 'finished' | 'in-progress' | 'to-do' | 'recurring' | 'draft' | 'rejected';
  /**
   * la priorité.
   */
  priority: 'normal' | 'urgent';
  /**
   * le type.
   *
   * @format iri-reference
   * @example https://example.com/
   */
  type: string;
  /**
   * l'auteur.
   *
   * @format iri-reference
   * @example https://example.com/
   */
  author?: string;
  /**
   * l'employeur.
   *
   * @format iri-reference
   * @example https://example.com/
   */
  employer?: string;
  /**
   * la localisation.
   *
   * @format iri-reference
   * @example https://example.com/
   */
  location: string;
  /**
   * la date de fin.
   *
   * @format date-time
   */
  endedAt?: string | null;
  /**
   * les intervenants.
   */
  participants?: string[];
  /**
   * les commentaires.
   */
  comments?: string[];
  /**
   * les photos.
   */
  pictures?: string[];
  /**
   * @format date-time
   */
  startAt?: string | null;
  /**
   * @format date-time
   */
  dueDate?: string | null;
  /**
   * @format iri-reference
   * @example https://example.com/
   */
  recurrenceReference?: string | null;
  /**
   * liste des interventions crées automatiquement liée à cette intervention récurrente
   */
  generatedInterventions?: string[];
  /**
   * @format date-time
   */
  endAt?: string | null;
  /**
   * @default onetime
   * @example onetime
   */
  frequency?: 'onetime' | 'daily' | 'weekly' | 'monthly' | 'yearly';
  triggerAt?: string | null;
  exceptions?: string[] | null;
  /**
   * @default 1
   * @example 1
   */
  frequencyInterval?: number;
  title?: string;
  /**
   * Renvoie le statut sous forme de string
   */
  statusAsString?: string;
  recurring?: boolean;
};

/**
 * L'entité représentant une intervention.
 *
 * @deprecated false
 */
export type InterventionInterventionPatch = {
  /**
   * la description
   */
  description?: string | null;
  /**
   * le statut.
   */
  status: 'to-validate' | 'blocked' | 'finished' | 'in-progress' | 'to-do' | 'recurring' | 'draft' | 'rejected';
  /**
   * la priorité.
   */
  priority: 'normal' | 'urgent';
  /**
   * le type.
   *
   * @format iri-reference
   * @example https://example.com/
   */
  type: string;
  /**
   * la localisation.
   */
  location: LocationInterventionPatch;
  /**
   * la date de fin.
   *
   * @format date-time
   */
  endedAt?: string | null;
  /**
   * les intervenants.
   */
  participants?: string[];
  /**
   * les photos.
   */
  pictures?: PictureInterventionPatch[];
  /**
   * @format date-time
   */
  startAt?: string | null;
  /**
   * @format date-time
   */
  dueDate?: string | null;
  /**
   * @format date-time
   */
  endAt?: string | null;
  /**
   * @default onetime
   * @example onetime
   */
  frequency?: 'onetime' | 'daily' | 'weekly' | 'monthly' | 'yearly';
  /**
   * @default 1
   * @example 1
   */
  frequencyInterval?: number;
  title?: string;
};

/**
 * L'entité représentant une intervention.
 *
 * @deprecated false
 */
export type InterventionInterventionPost = {
  /**
   * la description
   */
  description?: string | null;
  /**
   * le statut.
   */
  status: 'to-validate' | 'blocked' | 'finished' | 'in-progress' | 'to-do' | 'recurring' | 'draft' | 'rejected';
  /**
   * la priorité.
   */
  priority: 'normal' | 'urgent';
  /**
   * le type.
   *
   * @format iri-reference
   * @example https://example.com/
   */
  type: string;
  /**
   * l'employeur.
   *
   * @format iri-reference
   * @example https://example.com/
   */
  employer?: string;
  /**
   * la localisation.
   */
  location: LocationInterventionPost;
  /**
   * la date de fin.
   *
   * @format date-time
   */
  endedAt?: string | null;
  /**
   * les intervenants.
   */
  participants?: string[];
  /**
   * les photos.
   */
  pictures?: string[];
  /**
   * @format date-time
   */
  startAt?: string | null;
  /**
   * @format date-time
   */
  dueDate?: string | null;
  /**
   * @format date-time
   */
  endAt?: string | null;
  /**
   * @default onetime
   * @example onetime
   */
  frequency?: 'onetime' | 'daily' | 'weekly' | 'monthly' | 'yearly';
  /**
   * @default 1
   * @example 1
   */
  frequencyInterval?: number;
  title?: string;
};

/**
 * L'entité représentant une intervention.
 *
 * @deprecated false
 */
export type InterventionInterventionViewInterventionGet = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * identifiant logique avec une numérotation pour chaque employer
   */
  logicId?: number;
  /**
   * la date de création.
   *
   * @format date-time
   */
  createdAt?: string;
  /**
   * la description
   */
  description?: string | null;
  /**
   * le statut.
   */
  status: 'to-validate' | 'blocked' | 'finished' | 'in-progress' | 'to-do' | 'recurring' | 'draft' | 'rejected';
  /**
   * la priorité.
   */
  priority: 'normal' | 'urgent';
  /**
   * le type.
   */
  type: UserUserview;
  /**
   * l'auteur.
   */
  author?: UserUserview;
  /**
   * l'employeur.
   *
   * @format iri-reference
   * @example https://example.com/
   */
  employer?: string;
  /**
   * la localisation.
   */
  location: LocationInterventionViewInterventionGet;
  /**
   * la date de fin.
   *
   * @format date-time
   */
  endedAt?: string | null;
  /**
   * les intervenants.
   */
  participants?: UserInterventionViewInterventionGet[];
  /**
   * les commentaires.
   */
  comments?: CommentInterventionViewInterventionGet[];
  /**
   * les photos.
   */
  pictures?: PictureInterventionViewInterventionGet[];
  /**
   * @format date-time
   */
  startAt?: string | null;
  /**
   * @format date-time
   */
  dueDate?: string | null;
  /**
   * @format date-time
   */
  endAt?: string | null;
  /**
   * @default onetime
   * @example onetime
   */
  frequency?: 'onetime' | 'daily' | 'weekly' | 'monthly' | 'yearly';
  /**
   * @default 1
   * @example 1
   */
  frequencyInterval?: number;
  title?: string;
  recurring?: boolean;
};

/**
 * L'entité représentant une intervention.
 *
 * @deprecated false
 */
export type InterventionInterventionRejectionInput = {
  reason: string;
  details: string;
};

/**
 * L'entité représentant une localisation.
 *
 * @deprecated false
 */
export type Location = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * la rue.
   *
   * @maxLength 100
   */
  street?: string | null;
  /**
   * le complément d'adresse.
   *
   * @maxLength 500
   */
  rest?: string | null;
  /**
   * le code postal.
   */
  postcode?: string | null;
  /**
   * la ville.
   *
   * @maxLength 163
   */
  city?: string | null;
  /**
   * la longitude.
   */
  longitude: string;
  /**
   * la latitude.
   */
  latitude: string;
};

/**
 * @deprecated false
 */
export type LocationInterventionPatch = {
  /**
   * la rue.
   *
   * @maxLength 100
   */
  street?: string | null;
  /**
   * le complément d'adresse.
   *
   * @maxLength 500
   */
  rest?: string | null;
  /**
   * le code postal.
   */
  postcode?: string | null;
  /**
   * la ville.
   *
   * @maxLength 163
   */
  city?: string | null;
  /**
   * la longitude.
   */
  longitude: string;
  /**
   * la latitude.
   */
  latitude: string;
};

/**
 * @deprecated false
 */
export type LocationInterventionPost = {
  /**
   * la rue.
   *
   * @maxLength 100
   */
  street?: string | null;
  /**
   * le complément d'adresse.
   *
   * @maxLength 500
   */
  rest?: string | null;
  /**
   * le code postal.
   */
  postcode?: string | null;
  /**
   * la ville.
   *
   * @maxLength 163
   */
  city?: string | null;
  /**
   * la longitude.
   */
  longitude: string;
  /**
   * la latitude.
   */
  latitude: string;
};

/**
 * @deprecated false
 */
export type LocationInterventionViewInterventionGet = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * la rue.
   *
   * @maxLength 100
   */
  street?: string | null;
  /**
   * le complément d'adresse.
   *
   * @maxLength 500
   */
  rest?: string | null;
  /**
   * le code postal.
   */
  postcode?: string | null;
  /**
   * la ville.
   *
   * @maxLength 163
   */
  city?: string | null;
  /**
   * la longitude.
   */
  longitude: string;
  /**
   * la latitude.
   */
  latitude: string;
};

/**
 * L'entité représentant une photo.
 *
 * @deprecated false
 */
export type Picture = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * le nom du fichier.
   */
  fileName: string;
  /**
   * l'URL.
   */
  url?: string | null;
  /**
   * la date de création.
   *
   * @format date-time
   */
  createdAt?: string;
  /**
   * l'étiquette.
   */
  tag?: ('after' | 'before' | 'avatar' | any) | ('after' | 'before' | 'avatar' | any);
  /**
   * référence.
   *
   * @format iri-reference
   * @example https://example.com/
   */
  intervention?: string | null;
};

/**
 * L'entité représentant une photo.
 *
 * @deprecated false
 */
export type PictureInterventionPatch = {
  /**
   * référence.
   */
  intervention?: InterventionInterventionPatch | null;
};

/**
 * @deprecated false
 */
export type PictureInterventionViewInterventionGet = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * le nom du fichier.
   */
  fileName: string;
  /**
   * l'URL.
   */
  url?: string | null;
  /**
   * l'étiquette.
   */
  tag?: ('after' | 'before' | 'avatar' | any) | ('after' | 'before' | 'avatar' | any);
};

/**
 * @deprecated false
 */
export type PictureInterventionViewInterventionGetCollection = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * le nom du fichier.
   */
  fileName: string;
  /**
   * l'URL.
   */
  url?: string | null;
  /**
   * l'étiquette.
   */
  tag?: ('after' | 'before' | 'avatar' | any) | ('after' | 'before' | 'avatar' | any);
};

/**
 * @deprecated false
 */
export type PictureUserViewUserGet = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * le nom du fichier.
   */
  fileName: string;
  /**
   * l'URL.
   */
  url?: string | null;
  /**
   * l'étiquette.
   */
  tag?: ('after' | 'before' | 'avatar' | any) | ('after' | 'before' | 'avatar' | any);
};

/**
 * @deprecated false
 */
export type PictureUserViewUserGetCollection = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * le nom du fichier.
   */
  fileName: string;
  /**
   * l'URL.
   */
  url?: string | null;
  /**
   * l'étiquette.
   */
  tag?: ('after' | 'before' | 'avatar' | any) | ('after' | 'before' | 'avatar' | any);
};

/**
 * @deprecated false
 */
export type PictureUserViewUserGetCollectionUserGet = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * le nom du fichier.
   */
  fileName: string;
  /**
   * l'URL.
   */
  url?: string | null;
  /**
   * l'étiquette.
   */
  tag?: ('after' | 'before' | 'avatar' | any) | ('after' | 'before' | 'avatar' | any);
};

/**
 * @deprecated false
 */
export type TypeInterventionViewInterventionGet = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * le nom.
   */
  name: string;
  /**
   * la catégorie.
   */
  category: CategoryInterventionViewInterventionGet;
  /**
   * la photo.
   */
  picture: string;
  /**
   * la description.
   */
  description: string | null;
};

/**
 * L'entité représentant un utilisateur.
 *
 * @deprecated false
 */
export type User = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * l'identifiant de connexion.
   */
  login: string;
  /**
   * le mot de passe.
   */
  password?: string;
  /**
   * le prénom.
   */
  firstname: string;
  /**
   * le nom.
   */
  lastname: string;
  /**
   * l'e-mail.
   */
  email?: string | null;
  /**
   * le numéro de téléphone.
   */
  phoneNumber?: string | null;
  /**
   * la date de création.
   *
   * @format date-time
   */
  createdAt?: string;
  /**
   * la photo.
   *
   * @format iri-reference
   * @example https://example.com/
   */
  picture?: string | null;
  /**
   * l'employeur.
   *
   * @format iri-reference
   * @example https://example.com/
   */
  employer?: string;
  /**
   * si le compte est actif.
   *
   * @default true
   * @example true
   */
  active: boolean;
  /**
   * la date de la dernière connexion.
   *
   * @format date-time
   */
  connectedAt?: string | null;
  /**
   * les rôles.
   * it can have only 1 role
   */
  roles?: ('ROLE_AGENT' | 'ROLE_ADMIN_EMPLOYER' | 'ROLE_DIRECTOR' | 'ROLE_ELECTED' | 'ROLE_ADMIN')[];
  userIdentifier?: string;
  role?: string;
};

/**
 * @deprecated false
 */
export type UserInterventionViewInterventionGet = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * le prénom.
   */
  firstname: string;
  /**
   * le nom.
   */
  lastname: string;
  /**
   * l'e-mail.
   */
  email?: string | null;
  /**
   * le numéro de téléphone.
   */
  phoneNumber?: string | null;
  /**
   * la photo.
   */
  picture?: PictureInterventionViewInterventionGet | null;
  role?: string;
};

/**
 * L'entité représentant un utilisateur.
 *
 * @deprecated false
 */
export type UserUserPost = {
  /**
   * l'identifiant de connexion.
   */
  login: string;
  /**
   * le mot de passe.
   */
  password?: string;
  /**
   * le prénom.
   */
  firstname: string;
  /**
   * le nom.
   */
  lastname: string;
  /**
   * l'e-mail.
   */
  email?: string | null;
  /**
   * le numéro de téléphone.
   */
  phoneNumber?: string | null;
  /**
   * la photo.
   *
   * @format iri-reference
   * @example https://example.com/
   */
  picture?: string | null;
  /**
   * l'employeur.
   *
   * @format iri-reference
   * @example https://example.com/
   */
  employer?: string;
  /**
   * les rôles.
   * it can have only 1 role
   */
  roles?: ('ROLE_AGENT' | 'ROLE_ADMIN_EMPLOYER' | 'ROLE_DIRECTOR' | 'ROLE_ELECTED' | 'ROLE_ADMIN')[];
};

/**
 * L'entité représentant un utilisateur.
 *
 * @deprecated false
 */
export type UserUserViewAgentGetCollection = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * l'identifiant de connexion.
   */
  login: string;
  /**
   * le prénom.
   */
  firstname: string;
  /**
   * le nom.
   */
  lastname: string;
  /**
   * l'e-mail.
   */
  email?: string | null;
  /**
   * le numéro de téléphone.
   */
  phoneNumber?: string | null;
  /**
   * la date de création.
   *
   * @format date-time
   */
  createdAt?: string;
  /**
   * la photo.
   *
   * @format iri-reference
   * @example https://example.com/
   */
  picture?: string | null;
  /**
   * l'employeur.
   *
   * @format iri-reference
   * @example https://example.com/
   */
  employer?: string;
  /**
   * si le compte est actif.
   *
   * @default true
   * @example true
   */
  active: boolean;
  /**
   * la date de la dernière connexion.
   *
   * @format date-time
   */
  connectedAt?: string | null;
  /**
   * les rôles.
   * it can have only 1 role
   */
  roles?: ('ROLE_AGENT' | 'ROLE_ADMIN_EMPLOYER' | 'ROLE_DIRECTOR' | 'ROLE_ELECTED' | 'ROLE_ADMIN')[];
  role?: string;
};

/**
 * L'entité représentant un utilisateur.
 *
 * @deprecated false
 */
export type UserUserViewUserGet = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * l'identifiant de connexion.
   */
  login: string;
  /**
   * le prénom.
   */
  firstname: string;
  /**
   * le nom.
   */
  lastname: string;
  /**
   * l'e-mail.
   */
  email?: string | null;
  /**
   * le numéro de téléphone.
   */
  phoneNumber?: string | null;
  /**
   * la date de création.
   *
   * @format date-time
   */
  createdAt?: string;
  /**
   * la photo.
   */
  picture?: PictureUserViewUserGet | null;
  /**
   * l'employeur.
   *
   * @format iri-reference
   * @example https://example.com/
   */
  employer?: string;
  /**
   * si le compte est actif.
   *
   * @default true
   * @example true
   */
  active: boolean;
  /**
   * la date de la dernière connexion.
   *
   * @format date-time
   */
  connectedAt?: string | null;
  /**
   * les rôles.
   * it can have only 1 role
   */
  roles?: ('ROLE_AGENT' | 'ROLE_ADMIN_EMPLOYER' | 'ROLE_DIRECTOR' | 'ROLE_ELECTED' | 'ROLE_ADMIN')[];
  role?: string;
};

/**
 * L'entité représentant un utilisateur.
 *
 * @deprecated false
 */
export type UserUserViewUserGetCollection = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * l'identifiant de connexion.
   */
  login: string;
  /**
   * le prénom.
   */
  firstname: string;
  /**
   * le nom.
   */
  lastname: string;
  /**
   * l'e-mail.
   */
  email?: string | null;
  /**
   * le numéro de téléphone.
   */
  phoneNumber?: string | null;
  /**
   * la date de création.
   *
   * @format date-time
   */
  createdAt?: string;
  /**
   * la photo.
   */
  picture?: PictureUserViewUserGetCollection | null;
  /**
   * l'employeur.
   */
  employer?: EmployerUserViewUserGetCollection;
  /**
   * si le compte est actif.
   *
   * @default true
   * @example true
   */
  active: boolean;
  /**
   * la date de la dernière connexion.
   *
   * @format date-time
   */
  connectedAt?: string | null;
  /**
   * les rôles.
   * it can have only 1 role
   */
  roles?: ('ROLE_AGENT' | 'ROLE_ADMIN_EMPLOYER' | 'ROLE_DIRECTOR' | 'ROLE_ELECTED' | 'ROLE_ADMIN')[];
  role?: string;
};

/**
 * L'entité représentant un utilisateur.
 *
 * @deprecated false
 */
export type UserUserViewUserGetCollectionUserGet = {
  /**
   * l'identifiant.
   */
  id?: number;
  /**
   * l'identifiant de connexion.
   */
  login: string;
  /**
   * le prénom.
   */
  firstname: string;
  /**
   * le nom.
   */
  lastname: string;
  /**
   * l'e-mail.
   */
  email?: string | null;
  /**
   * le numéro de téléphone.
   */
  phoneNumber?: string | null;
  /**
   * la date de création.
   *
   * @format date-time
   */
  createdAt?: string;
  /**
   * la photo.
   */
  picture?: PictureUserViewUserGetCollectionUserGet | null;
  /**
   * l'employeur.
   */
  employer?: EmployerUserViewUserGetCollectionUserGet;
  /**
   * si le compte est actif.
   *
   * @default true
   * @example true
   */
  active: boolean;
  /**
   * la date de la dernière connexion.
   *
   * @format date-time
   */
  connectedAt?: string | null;
  /**
   * les rôles.
   * it can have only 1 role
   */
  roles?: ('ROLE_AGENT' | 'ROLE_ADMIN_EMPLOYER' | 'ROLE_DIRECTOR' | 'ROLE_ELECTED' | 'ROLE_ADMIN')[];
  role?: string;
};
